Unit AMMKR_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AMMKR(var IUT :Array of Integer; var JUT :Array of Integer;
                var IB :Array of Integer; var JB :Array of Integer;
                NR :Integer; NC :Integer; var IX :Array of Integer;
                var JX :Array of Integer; var IP :Array of Integer);
                
implementation

procedure AMMKR(var IUT :Array of Integer; var JUT :Array of Integer;
                var IB :Array of Integer; var JB :Array of Integer;
                NR :Integer; NC :Integer; var IX :Array of Integer;
                var JX :Array of Integer; var IP :Array of Integer);
var
JP,IBA,IBB,JJ,J,I,IUA,IUB,IXA,IXB,KP,K :Integer;
C :Real;
label
_10,_20,_30,_40,_50,_60,_70;
begin

{           -  }
{            U  -     }
{       ,    RR(L)U,  - }
{        ,    RR()U.      }
{              }
{        RR()U. }


{   IU, JU -    U   RR(L)U;  }

{     I, J -       RR()U;  }

{         NR -    U     }
{                 (: ); }

{         N -        (: );  }

{     I, J -        }
{               RR()U; }

{         I -    N,    }
{                 }


{            - }
{       I  }

for I:=1 to NC do
 begin
_10:
  IP[I-1] := 0;
 end;
JP := 1;
IX[0] := 1;

{             }

for I:=1 to NR do
 begin
  IBA := IB[I-1];
  IBB := IB[I+0]-1;
  if ( IBB < IBA ) 
   then goto _30;

{        I  ,      }

  for JJ:=IBA to IBB do
   begin
    J := JB[JJ-1];
    IP[J-1] := I;
    JX[JP-1] := J;
_20:
    JP := JP+1;
   end;

{        I  U,     }

_30:
  IUA := IUT[I-1];
  IUB := IUT[I+0]-1;
  if ( IUB < IUA ) 
   then goto _60;
  for JJ:=IUA to IUB do
   begin
    J := JUT[JJ-1];
    IXA := IX[J-1];
    IXB := IX[J+0]-1;
    if ( IXB < IXA ) 
     then goto _50;

{        J   }

    for KP:=IXA to IXB do
     begin
      K := JX[KP-1];
      if ( IP[K-1] = I ) 
       then goto _40;
      IP[K-1] := I;
      JX[JP-1] := K;
      JP := JP+1;
_40:
     end;
_50:
   end;
_60:
  IX[I+0] := JP;
_70:
 end;
end;

end.
